From fb51baa7ea0f1d7e36b9ae5a56ea10cb9354e222 Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Sun, 26 Jun 2022 00:31:26 +0100
Subject: [PATCH 10/21] Album ref name should include artist name

---
 mopidy_spotify/translator.py | 15 ++++++++++++---
 tests/test_browse.py         |  2 +-
 tests/test_translator.py     | 13 ++++++++++---
 3 files changed, 23 insertions(+), 7 deletions(-)

diff --git a/mopidy_spotify/translator.py b/mopidy_spotify/translator.py
index d180fa8e..fb9b640c 100644
--- a/mopidy_spotify/translator.py
+++ b/mopidy_spotify/translator.py
@@ -110,8 +110,16 @@ def web_to_album_ref(web_album):
     if not valid_web_data(web_album, "album"):
         return
 
-    uri = web_album["uri"]
-    return models.Ref.album(uri=uri, name=web_album.get("name", uri))
+    if "name" in web_album:
+        artists = web_album.get("artists", [])
+        if artists and artists[0].get("name"):
+            name = f"{artists[0].get('name')} - {web_album['name']}"
+        else:
+            name = web_album["name"]
+    else:
+        name = web_album["uri"]
+
+    return models.Ref.album(uri=web_album["uri"], name=name)
 
 
 def web_to_album_refs(web_albums):
@@ -342,7 +350,8 @@ def web_to_album(web_album):
     ]
     artists = [a for a in artists if a]
 
-    return models.Album(uri=ref.uri, name=ref.name, artists=artists)
+    name = web_album.get("name", "Unknown album")
+    return models.Album(uri=ref.uri, name=name, artists=artists)
 
 
 def web_to_track(web_track, bitrate=None, album=None):
diff --git a/tests/test_browse.py b/tests/test_browse.py
index 9b2bc277..e66f18f2 100644
--- a/tests/test_browse.py
+++ b/tests/test_browse.py
@@ -511,7 +511,7 @@ def test_browse_your_music_albums(web_client_mock, web_album_mock, provider):
     )
     assert results == [results[0]] * 4
     assert results[0] == models.Ref.album(
-        uri="spotify:album:def", name="DEF 456"
+        uri="spotify:album:def", name="ABBA - DEF 456"
     )
 
 
diff --git a/tests/test_translator.py b/tests/test_translator.py
index 460158f1..4686d9ab 100644
--- a/tests/test_translator.py
+++ b/tests/test_translator.py
@@ -323,6 +323,13 @@ def test_successful_translation(self, web_album_mock):
 
         assert ref.type == models.Ref.ALBUM
         assert ref.uri == "spotify:album:def"
+        assert ref.name == "ABBA - DEF 456"
+
+    def test_without_artists_uses_name(self, web_album_mock):
+        del web_album_mock["artists"]
+
+        ref = translator.web_to_album_ref(web_album_mock)
+
         assert ref.name == "DEF 456"
 
     def test_without_name_uses_uri(self, web_album_mock):
@@ -342,7 +349,7 @@ def test_returns_albums(self, web_album_mock):
 
         assert refs[0].type == models.Ref.ALBUM
         assert refs[0].uri == "spotify:album:def"
-        assert refs[0].name == "DEF 456"
+        assert refs[0].name == "ABBA - DEF 456"
 
     def test_returns_bare_albums(self, web_album_mock):
         web_albums = [web_album_mock] * 3
@@ -352,7 +359,7 @@ def test_returns_bare_albums(self, web_album_mock):
 
         assert refs[0].type == models.Ref.ALBUM
         assert refs[0].uri == "spotify:album:def"
-        assert refs[0].name == "DEF 456"
+        assert refs[0].name == "ABBA - DEF 456"
 
     def test_bad_albums_filtered(self, web_album_mock, web_artist_mock):
         refs = list(
@@ -757,7 +764,7 @@ def test_calls_web_to_album_ref(self, web_album_mock):
             ref_func_mock.assert_called_once_with(web_album_mock)
 
         assert album.uri == str(sentinel.uri)
-        assert album.name == str(sentinel.name)
+        assert album.name == "DEF 456"
 
     def test_returns_none_if_invalid_ref(self, web_album_mock):
         with patch.object(translator, "web_to_album_ref", return_value=None):

